#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,int *A7,float *B0,float *B1,float *B2,float *B3,float *B4,int N){
for(int i=0;i<N;i++){
A0[i] = A6[i];
A1[i] = A7[i]*A7[i]*A7[i];
A2[i] = A7[i]/A6[i];
A3[i] = A7[i]+A5[i]/A7[i]/A6[i];
A4[i] = A6[i]-A6[i]-A5[i]/A7[i];
B0[i] = B3[i]/B3[i];
}
}

int main(int argc,char **argv) {
int size=924392;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
int *A7;
A7 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
for(int i=0;i<924392;i++){
A0[i] = 0*i+1;
A1[i] = 48*i+1;
A2[i] = 11+i+1;
A3[i] = 83*i+1;
A4[i] = 85*i+1;
A5[i] = 56+i+1;
A6[i] = 72+i+1;
A7[i] = 79*i+1;
B0[i] = 10.2153396964+i+1;
B1[i] = 16.9417870332*i+1;
B2[i] = 94.4633614094*i+1;
B3[i] = 11.6539092131*i+1;
B4[i] = 74.7461890372*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,A7,B0,B1,B2,B3,B4,924392);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(A6);
free(A7);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
printf("\n");return 0; }